Name:        calibre
Version:     2.60.0
Release:     %mkrel 1
Summary:     E-book converter and library management
Group:       Text tools
License:     GPLv3
URL:         http://calibre-ebook.com/
Source0:     http://code.calibre-ebook.com/dist/src/%{name}-%{version}.tar.xz
Source2:       %{name}-mount-helper
Patch1:        calibre-2.9.0-fdo-no_update.patch
Patch4:        %{name}-python2-env-fix.patch
Patch6:        calibre-2.6.0-fdo-nodisplay.patch
Patch8:        calibre-2.20.0-mga-uppercase_digit_in_regex_core.patch
BuildRequires:    python >= 2.7.1
BuildRequires:    %{_lib}python-devel >= 2.7.1
BuildRequires:    %{_lib}magick-devel >= 6.9.4.0
BuildRequires:    python-setuptools
BuildRequires:    %{_lib}qt5base5-devel
BuildRequires:    %{_lib}qt5core-devel
BuildRequires:    %{_lib}qt5platformsupport-devel
BuildRequires:    %{_lib}qt5gui-devel
BuildRequires:    python-qt5-devel
BuildRequires:    %{_lib}poppler-qt5-devel >= 0.12
BuildRequires:    %{_lib}poppler-glib-devel
BuildRequires:    %{_lib}podofo-devel
BuildRequires:    desktop-file-utils
BuildRequires:    python-mechanize
BuildRequires:    python-lxml
BuildRequires:    python-dateutil
BuildRequires:    python-six
BuildRequires:    python-imaging
BuildRequires:    python-apsw
BuildRequires:    xdg-utils
BuildRequires:    python-beautifulsoup
BuildRequires:    %{_lib}chm-devel
BuildRequires:    python-cssutils >= 0.9.9
BuildRequires:    python-cssselect
BuildRequires:    %{_lib}sqlite3-devel
BuildRequires:    %{_lib}icu-devel
BuildRequires:    unzip
BuildRequires:    libwmf-devel
BuildRequires:    %{_lib}mtp-devel
BuildRequires:    bash-completion
#
# If python-feedparser is installed at build time there's problems with links. 
# See https://bugzilla.redhat.com/show_bug.cgi?id=1026469
BuildConflicts: python-feedparser
Requires:    python-dbus
Requires:    python-qt5
Requires:    python-pypdf
Requires:    python-cherrypy
Requires:    python-cssutils
Requires:    python-cssselect
#Requires:    ImageMagick >= 6.9.4.0
Requires:    python-odf
Requires:    python-lxml
Requires:    python-imaging
Requires:    python-mechanize
Requires:    python-dateutil
Requires:    python-genshi
Requires:    python-beautifulsoup
Requires:    python-netifaces
Requires:    python-six
Requires:    poppler
# Require the packages of the files which are symlinked by calibre
Requires:    fonts-ttf-liberation
# E-mail functionality requires this package
# see https://bugs.launchpad.net/calibre/+bug/739073
Requires:    python-dnspython
# Spotted by mga#11368
Requires:    python-apsw
Obsoletes: calibre-manager
Provides: calibre-manager = %version-%release
Obsoletes: Calibre
Provides: Calibre = %version-%release


%description
Calibre is meant to be a complete e-library solution. It includes library
management, format conversion, news feeds to ebook conversion as well as
e-book reader sync features.

Calibre is primarily a ebook cataloging program. It manages your ebook
collection for you. It is designed around the concept of the logical book,
i.e. a single entry in the database that may correspond to ebooks in several
formats. It also supports conversion to and from a dozen different ebook
formats.

Supported input formats are: MOBI, LIT, PRC, EPUB, CHM, ODT, HTML, CBR, CBZ,
RTF, TXT, PDF and LRS.

%prep
%setup -q
%apply_patches

# remove redundant / non-free fonts
rm -rf resources/fonts/*/

# dos2unix newline conversion
sed -i -e 's/\r//' src/calibre/web/feeds/recipes/*

# fix the location of liberation default font
sed -i -e "s:P('fonts/liberation/Liberation:('%{_datadir}/fonts/TTF/liberation/Liberation:" \
  src/calibre/utils/magick/draw.py
sed -i -e "s:P('fonts/liberation/Liberation:('%{_datadir}/fonts/TTF/liberation/Liberation:" \
  src/calibre/library/catalogs/epub_mobi_builder.py
sed -i -e "s:P('fonts/liberation/Liberation:('%{_datadir}/fonts/TTF/liberation/Liberation:" \
  src/calibre/ebooks/oeb/polish/tests/base.py
sed -i -e "s:P('fonts/liberation/Liberation:('%{_datadir}/fonts/TTF/liberation/Liberation:" \
  src/calibre/ebooks/__init__.py
sed -i -e "s:P('fonts/liberation/Liberation:('%{_datadir}/fonts/TTF/liberation/Liberation:" \
  src/calibre/web/feeds/news.py
sed -i -e "s:P('fonts/liberation/Liberation:('%{_datadir}/fonts/TTF/liberation/Liberation:" \
  recipes/*_ke.recipe

# remove shebangs
sed -i -e '/^#!\//, 1d' src/calibre/*/*/*/*.py
sed -i -e '/^#!\//, 1d' src/calibre/*/*/*.py
sed -i -e '/^#![ ]*\//, 1d' src/calibre/*/*.py
sed -i -e '/^#!\//, 1d' src/calibre/*.py
sed -i -e '/^#!\//, 1d' src/templite/*.py
sed -i -e '/^#!\//, 1d' resources/default_tweaks.py
sed -i -e '/^#!\//, 1d' recipes/*.recipe

chmod -x src/calibre/*/*/*/*.py
chmod -x src/calibre/*/*/*.py
chmod -x src/calibre/*/*.py
chmod -x src/calibre/*.py
chmod -x recipes/*.recipe

%build
#export PYTHONPATH="/usr/lib64/qt5/include/QtGui/"
OVERRIDE_CFLAGS="%{optflags}" python setup.py build

%install
mkdir -p %{buildroot}%{_datadir}

# create directories for xdg-utils
mkdir -p %{buildroot}%{_datadir}/icons
mkdir -p %{buildroot}%{_datadir}/icons/hicolor
mkdir -p %{buildroot}%{_datadir}/packages
mkdir -p %{buildroot}%{_datadir}/mime
mkdir -p %{buildroot}%{_datadir}/mime/packages
mkdir -p %{buildroot}%{_datadir}/applications
mkdir -p %{buildroot}%{_datadir}/desktop-directories

# create directory for gnome software data
mkdir -p %{buildroot}%{_datadir}/appdata

# create directory for calibre environment module
# the install script assumes it's there.
mkdir -p %{buildroot}%{python2_sitelib}

# create directory for completion files, so calibre knows where
# to install them
mkdir -p %{buildroot}%{_datadir}/bash-completion/completions
mkdir -p %{buildroot}%{_datadir}/zsh/site-functions

XDG_DATA_DIRS="%{buildroot}%{_datadir}" \
XDG_UTILS_INSTALL_MODE="system" \
LIBPATH="%{_libdir}" \
python2 setup.py install --root=%{buildroot}%{_prefix} \
            --prefix=%{_prefix} \
            --libdir=%{_libdir} \
            --staging-libdir=%{buildroot}%{_libdir} \
# remove shebang from init_calibre.py here because
# it just got spawned by the install script
sed -i -e '/^#!\//, 1d' %{buildroot}%{python2_sitelib}/init_calibre.py

# icons
mkdir -p %{buildroot}%{_datadir}/pixmaps/
cp -p resources/images/library.png        \
    %{buildroot}%{_datadir}/pixmaps/%{name}-gui.png
cp -p resources/images/viewer.png        \
    %{buildroot}%{_datadir}/pixmaps/calibre-viewer.png
cp -p resources/images/tweak.png        \
    %{buildroot}%{_datadir}/pixmaps/calibre-ebook-edit.png

# every file is empty here
find %{buildroot}%{_datadir}/mime -maxdepth 1 -type f|xargs rm -f

# the portable batch (>=0.8.5) is not needed
rm -f %{buildroot}%{_bindir}/calibre-portable.bat

# packages aren't allowed to register mimetypes like this
rm -f %{buildroot}%{_datadir}/applications/defaults.list
rm -f %{buildroot}%{_datadir}/applications/mimeinfo.cache
rm -f %{buildroot}%{_datadir}/mime/application/*.xml
rm -f %{buildroot}%{_datadir}/mime/text/*.xml

desktop-file-validate \
%{buildroot}%{_datadir}/applications/calibre-ebook-viewer.desktop
desktop-file-validate \
%{buildroot}%{_datadir}/applications/calibre-gui.desktop
desktop-file-validate \
%{buildroot}%{_datadir}/applications/calibre-lrfviewer.desktop

# mimetype icon for lrf
rm -rf %{buildroot}%{_datadir}/icons/hicolor/128x128
mkdir -p %{buildroot}%{_datadir}/icons/hicolor/scalable
mkdir -p %{buildroot}%{_datadir}/icons/hicolor/scalable/mimetypes
mkdir -p %{buildroot}%{_datadir}/icons/hicolor/scalable/apps
cp -p resources/images/mimetypes/lrf.png \
      %{buildroot}%{_datadir}/icons/hicolor/scalable/mimetypes/application-x-sony-bbeb.png
cp -p resources/images/viewer.png \
      %{buildroot}%{_datadir}/icons/hicolor/scalable/apps/calibre-viewer.png

# these are provided as separate packages
rm -rf %{buildroot}%{_libdir}/%{name}/{odf,cherrypy,pyPdf,encutils,cssutils}
rm -rf %{buildroot}%{_libdir}/%{name}/cal/utils/genshi
rm -rf %{buildroot}%{_libdir}/%{name}/cal/trac

# link to system fonts after we have deleted the non-free ones
# http://oldbugs.calibre-ebook.com/ticket/3832
mkdir -p %{buildroot}%{_datadir}/%{name}/fonts/prs500
ln -s %{_datadir}/fonts/TTF/liberation/LiberationSans-Regular.ttf \
      %{buildroot}%{_datadir}/%{name}/fonts/prs500/tt0003m_.ttf
ln -s %{_datadir}/fonts/TTF/liberation/LiberationSerif-Regular.ttf \
      %{buildroot}%{_datadir}/%{name}/fonts/prs500/tt0011m_.ttf
ln -s %{_datadir}/fonts/TTF/liberation/LiberationMono-Regular.ttf \
      %{buildroot}%{_datadir}/%{name}/fonts/prs500/tt0419m_.ttf

# rm empty feedparser files.
rm -rf %{buildroot}%{_libdir}/%{name}/%{name}/web/feeds/feedparser.*

ln -s %{python2_sitelib}/feedparser.py \
      %{buildroot}%{_libdir}/%{name}/%{name}/web/feeds/feedparser.py
ln -s %{python2_sitelib}/feedparser.pyc \
      %{buildroot}%{_libdir}/%{name}/%{name}/web/feeds/feedparser.pyc
ln -s %{python2_sitelib}/feedparser.pyo \
      %{buildroot}%{_libdir}/%{name}/%{name}/web/feeds/feedparser.pyo

# localization has changed since calibre-0.8.5
# locale.zip is treated internally at runtime
# so the traditional locale fixes are moot.
# locales should still be looked for in the proper place
# but under the new localization zip-based schema
sed -i -e 's:localization/locale.zip:%{_datadir}/%{name}/localization/locales.zip:' %{buildroot}%{_libdir}/%{name}/%{name}/utils/localization.py  

rm -f %{buildroot}%{_bindir}/%{name}-uninstall

cp -a %{SOURCE2} %{buildroot}%{_bindir}/


%files
%doc COPYRIGHT LICENSE Changelog.yaml
%{_bindir}/calibre
%{_bindir}/calibre-complete
%{_bindir}/calibre-customize
%{_bindir}/calibre-debug
%{_bindir}/calibre-parallel
%{_bindir}/calibre-server
%{_bindir}/calibre-smtp
%{_bindir}/calibre-mount-helper
%{_bindir}/calibredb
%{_bindir}/ebook-convert
%{_bindir}/ebook-device
%{_bindir}/ebook-meta
%{_bindir}/ebook-viewer
%{_bindir}/ebook-polish
%{_bindir}/ebook-edit
%{_bindir}/fetch-ebook-metadata
%{_bindir}/lrf2lrs
%{_bindir}/lrfviewer
%{_bindir}/lrs2lrf
%{_bindir}/markdown-calibre
%{_bindir}/web2disk
%{_datadir}/bash-completion/completions/%{name}
%{_datadir}/zsh/site-functions/_%{name}
%{_libdir}/%{name}
%{_datadir}/%{name}
%{_datadir}/pixmaps/*
%{_datadir}/applications/*.desktop
%{_datadir}/mime/packages/*
%{_datadir}/icons/hicolor/scalable/mimetypes/*
%{_datadir}/icons/hicolor/*/apps/*
%{_datadir}/icons/hicolor/*/mimetypes/*
%{_datadir}/appdata/%{name}-*.appdata.xml
%{python2_sitelib}/init_calibre.py*


%changelog
* Fri Jun 24 2016 woodhead <pp> 2.60.0-1pclos2016
- update

* Fri Jun 17 2016 woodhead <pp> 2.59.0-1pclos2016
- update

* Fri Jun 03 2016 woodhead <pp> 2.58.0-1pclos2016
- update

* Sat May 21 2016 woodhead <pp> 2.57.1-1pclos2016
- update

* Fri May 20 2016 woodhead <pp> 2.57.0-1pclos2016
- update
- acc changelog Req. ImageMagick is no longer needed

* Thu May 19 2016 bb <bb> 2.56.0-3pclos2016
- obsolete and provide calibre-manager to make
- it remove old calibre-manager during update

* Tue May 10 2016 woodhead <pp> 2.56.0-2pclos2016
- rebuild for new ImageMagick

* Fri Apr 29 2016 woodhead <pp> 2.56.0-1pclos2016
- update

* Sat Apr 16 2016 woodhead <pp> 2.55.0-1pclos2016
- update

* Tue Apr 05 2016 woodhead <pp> 2.54.0-2pclos2016
- added Req. python-six

* Tue Apr 05 2016 woodhead <pp> 2.54.0-1pclos2016
- imported package
